#####################################################################
#
#  (C) Copyright IBM Corp. 2008.
#  All Rights Reserved
#  Licensed Material - Property of IBM
#
#####################################################################

########################################################################
#
# wsadmin -connType NONE -lang jython 
#         -f configDB2type4jdbc.py <hostname> <dbPort> <db2jccPath>
#
########################################################################

import sys
def wsadminToList(inStr):
        outList=[]
        if (len(inStr)>0 and inStr[0]=='[' and inStr[-1]==']'):
                tmpList = inStr[1:-1].split() #splits space-separated lists,
        else:
                tmpList = inStr.split("\n")   #splits for Windows or Linux
        for item in tmpList:
                item = item.rstrip();         #removes any Windows "\r"
                if (len(item)>0):
                        outList.append(item)
        return outList
#endDef


hostname = sys.argv[0]
dbPort = sys.argv[1]
dbDriverClasspath = sys.argv[2]
print "configDB2type4jdbc.py " + hostname + " " + dbPort + " " + dbDriverClasspath + "\n\n"

######################################################################
#
# Update JDBC Provider
#
######################################################################

Separator = ':'
if (len(dbDriverClasspath)>0 and dbDriverClasspath[1]==':' and dbDriverClasspath[2]=='/'):
  print 'WINDOWS\n'
  Separator = ';'
else :
  print 'UNIX\n'

ClassPathList = []
ClassPathList.append(dbDriverClasspath + '/db2jcc.jar')
ClassPathList.append(dbDriverClasspath + '/db2jcc_license_cu.jar')
ClassPath = Separator.join(ClassPathList)
print "ClassPath = " + ClassPath + "\n"

CSMProvider = AdminConfig.getid("/JDBCProvider:CSMProvider/" )
AdminConfig.modify(CSMProvider, [["classpath", []]] )
AdminConfig.modify(CSMProvider, [["classpath", ClassPath]] )
AdminConfig.modify(CSMProvider, [["implementationClassName", "com.ibm.db2.jcc.DB2ConnectionPoolDataSource"]] )
AdminConfig.modify(CSMProvider, [["xa", "false"]] )
print "JDBC Provider = " + CSMProvider + "\n"


######################################################################
#
# Get DataSource CSMDS
#
######################################################################

CSMDataSource = AdminConfig.getid("/JDBCProvider:CSMProvider/DataSource:CSMDS/" )
print "DataSource = " + CSMDataSource + "\n"


######################################################################
#
# Get the database name
#
######################################################################

propSet = AdminConfig.showAttribute(CSMDataSource, 'propertySet')
print "propertySet = " + propSet + "\n"

resourceProps = AdminConfig.showAttribute(propSet, 'resourceProperties')
print "resourceProperties = " + resourceProps + "\n"

dbName = ''
resourcePropsArray = resourceProps[1:len(resourceProps)-1].split(' ') 
for prop in resourcePropsArray:
  propname = AdminConfig.showAttribute(prop, 'name')
  if propname == 'databaseName':
    dbName = AdminConfig.showAttribute(prop, 'value')
    print "Database name = " + dbName + "\n"


######################################################################
#
# Set DataSource type 4 Properties
#
######################################################################

propertySet = AdminConfig.create("J2EEResourcePropertySet", CSMDataSource, [] )

attrs = [["name", "databaseName"], ["type", "java.lang.String"], ["value", dbName]]
AdminConfig.create("J2EEResourceProperty", propertySet, attrs )

attrs = [["name", "driverType"], ["type", "java.lang.Integer"], ["value", 4]]
AdminConfig.create("J2EEResourceProperty", propertySet, attrs )

attrs = [["name", "serverName"], ["type", "java.lang.String"], ["value", hostname]]
AdminConfig.create("J2EEResourceProperty", propertySet, attrs )

attrs = [["name", "portNumber"], ["type", "java.lang.Integer"], ["value", dbPort]]
AdminConfig.create("J2EEResourceProperty", propertySet, attrs )

######################################################################
#
# Configure the Connection Pool parameters
#
######################################################################

print "Configuring Connection Pool Settings..."
poolid = AdminConfig.showAttribute(CSMDataSource, "connectionPool" )
AdminConfig.modify(poolid, [["maxConnections", 30], ["connectionTimeout", 1800]] )
print "Connection Pool Settings Configured."

#######################################################################
#
# Save configuration
#
#######################################################################

AdminConfig.save( )
